lVG <- function(theta,mu,sigma2,gammap,y)

# this function computes the variance-gamma log-likelihood; note that theta = nu
{
epsilon1 = 10^(-5)
N = length(y)
vettore = abs((y - mu)/sigma2)
indici1 = which(vettore<epsilon1)
indici2 = which(vettore>=epsilon1)
N1 = length(indici1==T)
f = rep(0,N)
for (i in indici2)
{
f[i] = (((2 * exp(gammap * (y[i] - mu)/sigma2))/(1/theta^(theta) *
                    sqrt(2 * pi) * sqrt(sigma2) * gamma(theta))) * ((abs(y[i] -
                    mu)/sqrt(2 * (sigma2)*theta + gammap^2))^(theta -
                    1/2)) * besselK(x = ((1/sigma2) * abs(y[i] -
                    mu) * sqrt((2 * sigma2*theta) + gammap^2)),
                    nu = (theta - 1/2), expon.scaled = F) )
}
if (N1>0 && theta>.5)
{
   fits = splinefun(x=y[indici2],y=f[indici2])
   f[indici1] = fits(x=y[indici1])
}
if (N1>0 && theta<=.5)
{
  dati = y[indici1]
  f[indici1] = gamma(theta-.5) / (sqrt(sigma2*2*pi)*(1/theta)^theta*gamma(theta)) * ((2*sigma2)/sqrt(2*sigma2*theta+gammap^2))
}
lVG = sum(log(f))
lVG
}
